/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomXMLSerializer_H__
#define __GdomXMLSerializer_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomNode.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomXMLSerializer GdomXMLSerializer;
typedef struct _GdomXMLSerializerClass GdomXMLSerializerClass;


#define GDOM_TYPE_XML_SERIALIZER            (gdom_xml_serializer_get_type())
#define GDOM_XML_SERIALIZER(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_XML_SERIALIZER, GdomXMLSerializer))
#define GDOM_XML_SERIALIZER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_XML_SERIALIZER, GdomXMLSerializer)Class)
#define GDOM_IS_XML_SERIALIZER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_XML_SERIALIZER))
#define GDOM_IS_XML_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_XML_SERIALIZER))
#define GDOM_XML_SERIALIZER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_XML_SERIALIZER, GdomXMLSerializerClass))

typedef struct _GdomXMLSerializerPrivate GdomXMLSerializerPrivate;

struct _GdomXMLSerializer {
    GdomDOMObject parent_instance;
    GdomXMLSerializerPrivate *priv;
};

struct _GdomXMLSerializerClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_xml_serializer_get_type (void);

WEBKIT_API gchar *
gdom_xml_serializer_serialize_to_string (GdomXMLSerializer *thiz, GdomNode * node);

G_END_DECLS

#endif /* __GdomXMLSerializer_H__ */
